{by Alexey Monastyrenko}
{slightly changed by Valery Votintsev ( vv ) }

{$R-,Q-,S-,Q-}
uses Crt,SetPAL;

type TScr = array[0..199,0..319] of Byte;
var Scr: TScr absolute $A000:$0000;
type TScr2 = array[0..63999] of byte;

procedure VIDMode(Mode : Byte);assembler;
  asm mov ah,$00;  mov al,mode; int 10h; end;

procedure ChangePic(var Pic1:TScr; var Pal1:TPaletteLinear;
                    var Pic2:TScr; var Pal2:TPaletteLinear);
var I,J:Word;
    R1,R2,RR:Word;
    YMax:array[0..319] of Integer;
    YY:array[0..319] of Integer;
begin
  for I:=0 to 319 do begin
    YY[I]:=-Random(80);
    YMax[I]:=199;
  end;
  for j:=1 to 8 do
    for I:=j to 319-j do begin
      YY[I]:=(YY[I-1]+YY[I]*2+YY[I+1]) div 4;
    end;
  for I:=0 to 199+80 do begin
    for J:=0 to 319 do begin
      if YY[J]<YMax[J] then begin
        if YY[J]>=0 then Scr[YY[J],J]:=Pic1[YY[J],J];
        Inc(YY[J]);
      end else begin
        YY[J]:=0;
        Dec(YMax[J]);
      end;
{      Scr[YY[J],J]:=Pic2[YY[J],J];}
    end;
    for J:=0 to 256*3-1 do begin
      PaletteLinear[J]:=((199+80-I)*Pal2[J]+I*Pal1[J]+100) div (199+80);
    end;
    SetPalette;
    delay(2);
  end;
end;

var X,Y,X1,Y1:Integer;
    I,J:Longint;
    F:file;
    Scr3,Scr4: ^TScr;
    Pal3,Pal4:TPalette;
    Pal3L:TPaletteLinear absolute Pal3;
    PAL4L:TPaletteLinear absolute PAL4;
begin
  vidMode($13);                       { 320x200x256 graphics mode }
  GetMem(Scr3,320*200);

  GetMem(Scr4,320*200);
 repeat

  Assign(F,'monster.scr'); ReSet(F,1);
  BlockRead(F,Scr4^,320*200);
  Close(F);
  Assign(F,'monster.PAL'); ReSet(F,1);
  BlockRead(F,PAL4,SizeOf(TPaletteLinear));
  Close(F);

  Assign(F,'monhorse.scr'); ReSet(F,1);
  BlockRead(F,Scr3^,320*200);
  Close(F);
  Assign(F,'monhorse.PAL'); ReSet(F,1);
  BlockRead(F,Pal3,SizeOf(TPaletteLinear));
  Close(F);

  ChangePic(Scr3^,Pal3L,Scr4^,Pal4L); Delay(1000);
  ChangePic(Scr4^,Pal4L,Scr3^,Pal3L); Delay(1000);

 until KeyPressed;
  FreeMem(Scr4,320*200);
  FreeMem(Scr3,320*200);

{vv}  vidMode(3);      { Text mode }

end.