{Remove colors from the picture palitre}
{originally by Alexey Monastyrenko     }
{--------------------------------------}
{ changed by Valery Votintsev ( vv )   }
{     for more convenience only        }
{--------------------------------------}

uses Crt;

type TScr = array[0..199,0..319] of Byte;
type TPalette=array[0..255,0..2] of Byte;
     TP=array[0..2] of Byte;
var F,G:file;
    P:TPalette;
    S:^TScr;
    Scr:TScr absolute $A000:$0000;

procedure RemoveColor(N:Word);
var I,J,R,R1,N1,N2:Word;
begin
  R:=High(R);
  for I:=1 to N do begin
    for J:=0 to I-1 do begin
      R1:= Abs(P[I,0]-P[J,0])+Abs(P[I,1]-P[J,1])+Abs(P[I,2]-P[J,2]);
      if R1<R then begin
        R:=R1; N2:=I; N1:=J;
      end;
    end;
  end;

  P[N1,0]:=(P[N1,0]+P[N2,0]) shr 1;
  P[N1,1]:=(P[N1,1]+P[N2,1]) shr 1;
  P[N1,2]:=(P[N1,2]+P[N2,2]) shr 1;
  P[N2]:=P[N];

  for I:=0 to 199 do begin
    for J:=0 to 319 do begin
      if S^[I,J]=N2 then S^[I,J]:=N1;
      if S^[I,J]=N then S^[I,J]:=N2;
    end;
  end;
end;

procedure SortColorS;
var I,J,N1,X,Y:Word;
    R,R1:Integer;
    T:TP;
    B:Byte;
begin
  for J:=255 downto 1 do begin
    R:=Low(R);
    for I:=0 to J do begin
      R1:= Abs(P[I,0])+Abs(P[I,1])+Abs(P[I,2]);
      if R1>R then begin
        R:=R1;
        N1:=I;
      end;
    end;
    T:=TP(P[J]);
    P[J]:=P[N1];
    TP(P[N1]):=T;

    for Y:=0 to 199 do begin
      for X:=0 to 319 do begin
        if S^[Y,X]=N1 then S^[Y,X]:=J else
        if S^[Y,X]=J then S^[Y,X]:=N1;
      end;
    end;

    Write(J:3,^M)

  end;

end;


procedure SetPalette(P:TPalette);
type TPaletteLineAR=array[0..256*3-1] of Byte;
var I:Word;
begin
  Port[$3C8] := 0;
  for I := 0 to 256*3-1 do begin
    Port[$3C9] := TPaletteLineAR(P)[I]
  end;
end; {of SetPalette}

procedure VIDMode(Mode : Byte);assembler;
  asm mov ah,$00;  mov al,mode; int 10h; end;

{vv} Const PicName:string[7] = 'monster';

var N:Word;
{vv} c:char;

begin
  DIRectVideo:=False;
  VIDMode($13);
  GetMem(S,64000);
{VV  Assign(F,ParamStr(1)+'.scr'); ReSet(F,1);}
{vv}  Assign(F,PicName+'.scr'); ReSet(F,1);
  BlockRead(F,S^,64000); Scr:=S^;
  Close(F);
{vv  Assign(F,ParamStr(1)+'.pal'); ReSet(F,1);}
{vv}  Assign(F,PicName+'.pal'); ReSet(F,1);
  BlockRead(F,P,768);
  Close(F);
  SetPalette(P);
{vv}  Write(256:3,^M);
  ReadKey;
  for N:=255 downto 1 do begin
    RemoveColor(N);
    Scr:=S^;
    SetPalette(P);
{vv}    Write(N:3,^M);
{vv    if N=128 then begin
      Write('   ',^M);
    end;
}
{vv}  c:=ReadKey;
{vv}  If c=#27 then break;
  end;
{  SortColorS;}
  ReadKey;
  Scr:=S^;
  SetPalette(P);
  ReadKey;
  VIDMode($3);
  FreeMem(S,64000);
end.